Get commitments on-demand hot spots (scalar)

Note: This endpoint is in preview and is subject to change. If you have any feedback, contact Datadog support.

GET https://api.ap1.datadoghq.com/api/v2/cost/commitments/on-demand-hot-spots/scalarhttps://api.ap2.datadoghq.com/api/v2/cost/commitments/on-demand-hot-spots/scalarhttps://api.datadoghq.eu/api/v2/cost/commitments/on-demand-hot-spots/scalarhttps://api.ddog-gov.com/api/v2/cost/commitments/on-demand-hot-spots/scalarhttps://api.us2.ddog-gov.com/api/v2/cost/commitments/on-demand-hot-spots/scalarhttps://api.datadoghq.com/api/v2/cost/commitments/on-demand-hot-spots/scalarhttps://api.us3.datadoghq.com/api/v2/cost/commitments/on-demand-hot-spots/scalarhttps://api.us5.datadoghq.com/api/v2/cost/commitments/on-demand-hot-spots/scalar

Overview

Get scalar on-demand hot-spots data for cloud commitment programs, showing per-dimension breakdowns of on-demand spending with coverage metrics and potential savings. This endpoint requires the cloud_cost_management_read permission.

OAuth apps require the cloud_cost_management_read authorization scope to access this endpoint.

Arguments

Query Strings

Name

Type

Description

provider [required]

enum

Cloud provider for commitment programs (aws or azure).
Allowed enum values: aws, azure

product [required]

string

Cloud product identifier (for example, ec2, rds, virtualmachines).

start [required]

integer

Start of the query time range in Unix milliseconds.

end [required]

integer

End of the query time range in Unix milliseconds.

filterBy

string

Optional filter expression to narrow down results.

Response

OK

Response containing scalar on-demand hot-spots data for cloud commitment programs.

Expand All

Field

Type

Description

columns [required]

[object]

Array of scalar columns in the response.

meta

object

Metadata for a scalar column, including unit information.

unit [required]

object

Unit metadata for a numeric metric.

family [required]

string

The unit family (for example, percentage or money).

id [required]

int64

The unit identifier.

name [required]

string

The unit name (for example, percent or dollar).

plural [required]

string

The plural form of the unit name.

scale_factor [required]

double

The scale factor for the unit.

short_name [required]

string

The abbreviated unit name (for example, % or $).

name [required]

string

The column name.

type [required]

enum

The column type. "group" for dimension columns, "number" for metric columns. Allowed enum values: group,number

values [required]

[]

Values for a scalar column. Arrays of strings for group columns, numbers for value columns.

meta

object

Metadata for the on-demand hot-spots scalar response.

on_demand_filters [required]

string

Active on-demand filters applied to the response.

total [required]

[object]

Array of scalar columns in the response.

meta

object

Metadata for a scalar column, including unit information.

unit [required]

object

Unit metadata for a numeric metric.

family [required]

string

The unit family (for example, percentage or money).

id [required]

int64

The unit identifier.

name [required]

string

The unit name (for example, percent or dollar).

plural [required]

string

The plural form of the unit name.

scale_factor [required]

double

The scale factor for the unit.

short_name [required]

string

The abbreviated unit name (for example, % or $).

name [required]

string

The column name.

type [required]

enum

The column type. "group" for dimension columns, "number" for metric columns. Allowed enum values: group,number

values [required]

[]

Values for a scalar column. Arrays of strings for group columns, numbers for value columns.

{
  "columns": [
    {
      "meta": {
        "unit": {
          "family": "percentage",
          "id": 17,
          "name": "percent",
          "plural": "percent",
          "scale_factor": 1,
          "short_name": "%"
        }
      },
      "name": "utilization",
      "type": "group",
      "values": [
        0.85,
        0.72
      ]
    }
  ],
  "meta": {
    "on_demand_filters": "region:us-east-1"
  },
  "total": [
    {
      "meta": {
        "unit": {
          "family": "percentage",
          "id": 17,
          "name": "percent",
          "plural": "percent",
          "scale_factor": 1,
          "short_name": "%"
        }
      },
      "name": "utilization",
      "type": "group",
      "values": [
        0.85,
        0.72
      ]
    }
  ]
}

Bad Request

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Too many requests

API error response.

Expand All

Field

Type

Description

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Code Example

                  # Required query arguments
export provider="aws"
export product="ec2"
export start="1.6935264e+12"
export end="1.6961184e+12"
# Curl command
curl -X GET "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/cost/commitments/on-demand-hot-spots/scalar?provider=${provider}&product=${product}&start=${start}&end=${end}" \ -H "Accept: application/json" \ -H "DD-API-KEY: ${DD_API_KEY}" \ -H "DD-APPLICATION-KEY: ${DD_APP_KEY}"
"""
Get commitments on-demand hot spots (scalar) returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.cloud_cost_management_api import CloudCostManagementApi
from datadog_api_client.v2.model.commitments_provider import CommitmentsProvider

configuration = Configuration()
configuration.unstable_operations["get_commitments_on_demand_hotspots_scalar"] = True
with ApiClient(configuration) as api_client:
    api_instance = CloudCostManagementApi(api_client)
    response = api_instance.get_commitments_on_demand_hotspots_scalar(
        provider=CommitmentsProvider.AWS,
        product="product",
        start=9223372036854775807,
        end=9223372036854775807,
    )

    print(response)

Instructions

First install the library and its dependencies and then save the example to example.py and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
# Get commitments on-demand hot spots (scalar) returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.get_commitments_on_demand_hotspots_scalar".to_sym] = true
end
api_instance = DatadogAPIClient::V2::CloudCostManagementAPI.new
p api_instance.get_commitments_on_demand_hotspots_scalar(CommitmentsProvider::AWS, "product", 9223372036854775807, 9223372036854775807)

Instructions

First install the library and its dependencies and then save the example to example.rb and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
// Get commitments on-demand hot spots (scalar) returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.GetCommitmentsOnDemandHotspotsScalar", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewCloudCostManagementApi(apiClient)
	resp, r, err := api.GetCommitmentsOnDemandHotspotsScalar(ctx, datadogV2.COMMITMENTSPROVIDER_AWS, "product", 9223372036854775807, 9223372036854775807, *datadogV2.NewGetCommitmentsOnDemandHotspotsScalarOptionalParameters())

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `CloudCostManagementApi.GetCommitmentsOnDemandHotspotsScalar`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `CloudCostManagementApi.GetCommitmentsOnDemandHotspotsScalar`:\n%s\n", responseContent)
}

Instructions

First install the library and its dependencies and then save the example to main.go and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
// Get commitments on-demand hot spots (scalar) returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.CloudCostManagementApi;
import com.datadog.api.client.v2.model.CommitmentsOnDemandHotspotsScalarResponse;
import com.datadog.api.client.v2.model.CommitmentsProvider;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.getCommitmentsOnDemandHotspotsScalar", true);
    CloudCostManagementApi apiInstance = new CloudCostManagementApi(defaultClient);

    try {
      CommitmentsOnDemandHotspotsScalarResponse result =
          apiInstance.getCommitmentsOnDemandHotspotsScalar(
              CommitmentsProvider.AWS, "ec2", 1693526400000L, 1696118400000L);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println(
          "Exception when calling CloudCostManagementApi#getCommitmentsOnDemandHotspotsScalar");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}

Instructions

First install the library and its dependencies and then save the example to Example.java and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
// Get commitments on-demand hot spots (scalar) returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_cloud_cost_management::CloudCostManagementAPI;
use datadog_api_client::datadogV2::api_cloud_cost_management::GetCommitmentsOnDemandHotspotsScalarOptionalParams;
use datadog_api_client::datadogV2::model::CommitmentsProvider;

#[tokio::main]
async fn main() {
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.GetCommitmentsOnDemandHotspotsScalar", true);
    let api = CloudCostManagementAPI::with_config(configuration);
    let resp = api
        .get_commitments_on_demand_hotspots_scalar(
            CommitmentsProvider::AWS,
            "product".to_string(),
            9223372036854775807,
            9223372036854775807,
            GetCommitmentsOnDemandHotspotsScalarOptionalParams::default(),
        )
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}

Instructions

First install the library and its dependencies and then save the example to src/main.rs and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
/**
 * Get commitments on-demand hot spots (scalar) returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.getCommitmentsOnDemandHotspotsScalar"] =
  true;
const apiInstance = new v2.CloudCostManagementApi(configuration);

const params: v2.CloudCostManagementApiGetCommitmentsOnDemandHotspotsScalarRequest =
  {
    provider: "aws",
    product: "product",
    start: 9223372036854775807,
    end: 9223372036854775807,
  };

apiInstance
  .getCommitmentsOnDemandHotspotsScalar(params)
  .then((data: v2.CommitmentsOnDemandHotspotsScalarResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));

Instructions

First install the library and its dependencies and then save the example to example.ts and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"